function varargout = guiCosinor(varargin)
% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @guiCosinor_OpeningFcn, ...
                   'gui_OutputFcn',  @guiCosinor_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before guiCosinor is made visible.
function guiCosinor_OpeningFcn(hObject, eventdata, handles, varargin)
% Choose default command line output for guiCosinor
    handles.output = hObject;

% Update handles structure
    guidata(hObject, handles);
    
    %Button group
    set(handles.uibuttongroup1,'selectedobject',handles.rdbttnMul)

    %Obtener datos y graficarlos
    valores = getappdata (BiCA,'valores');
    vectt = getappdata (BiCA,'vectt');
    nomb = getappdata (BiCA,'nomb');

    axes(handles.axsDat);
    cla;
    plot (vectt,valores);

    xlim ([vectt(1) vectt(end)]);
    hold on;

    xlabel('Tiempo en das');
    ylabel(nomb);

   %Sliders
    %Inicial
    set(handles.sldrIni,'Min',1);
    set(handles.sldrIni,'Max',length(vectt));
    set(handles.sldrIni,'Value',1);
    
    x = [1,1];
    y = handles.axsDat.YLim;
    axes(handles.axsDat);
    handles.lini = plot(x,y,'r');
    set(handles.lini,'Visible','off')    
    guidata(hObject, handles);
    
    %Final
    set(handles.sldrFin,'Min',1);
    set(handles.sldrFin,'Max',length(vectt));
    set(handles.sldrFin,'Value',length(vectt));
    
    x = [get(handles.sldrFin,'Max'),get(handles.sldrFin,'Max')];
    y = handles.axsDat.YLim;
    axes(handles.axsDat);    
    handles.linf = plot(x,y,'r');
    set(handles.linf,'Visible','off')
   
   %Edts
    %Final
    set (handles.edtFinDes, 'String', floor(handles.axsDat.XLim(end)));
    
    %Actualizar
    guidata(hObject, handles);

% UIWAIT makes guiCosinor wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = guiCosinor_OutputFcn(hObject, eventdata, handles) 
% Get default command line output from handles structure
varargout{1} = handles.output;


function edtIni_Callback(hObject, eventdata, handles)

function edtIni_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edtFin_Callback(hObject, eventdata, handles)

function edtFin_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Al presionar botn Analizar
function pshbttnAna_Callback(hObject, eventdata, handles)
    %Obtener datos de la interfaz principal
    valores = getappdata (BiCA,'valores');
    nomb = getappdata (BiCA,'nomb');
    dxd = getappdata (BiCA,'dxd');
    
    valores = valores (floor(get(handles.sldrIni,'Value')):floor(get(handles.sldrFin,'Value')));
    
    t = 0:24*(1/dxd):length(valores)*(1/dxd*24)-(1/dxd*24);
    t = t';
  
    %Obtener datos de los cuadros de texto
    hri = str2double (get(handles.edtIni,'String'));
    hrf = str2double (get(handles.edtFin,'String'));
    cmin = str2double (get(handles.edtMin,'String'));
    
    %Discriminacin entre RndBttn seleccionado
    if get(handles.rdbttnMul,'Value') == 1          %Mltiple
        cosniv (t,valores,hri,hrf,cmin);         
    else                                            %Sencillo 
        [w,M,Amp,phi,pVal,R] = cper(t,valores,2*pi/hri,1);
        Acr = abs((rad2deg(phi)*6)/90);
        
        tf = t(1):0.05:t(end);
        f = M + Amp*cos((2*pi/hri)*tf+phi);

        figure('name','Anlisis de cosinor: Seal original y funcin ajustada');
        plot(t,valores); hold on;
            title('Ajuste de cosinor');
            xlabel('Tiempo en das');            
            %ylabel(nomb);
            ylabel('Actividad');           
            set(gca,'fontsize',12) 
        plot(tf,f,'r','LineWidth',2);
            legend('Original', 'Cosinor');
            xlim([min(tf) max(tf)]);
            
            tt= 0:1:floor(max(t));
            xticks(tt*24);
            xticklabels(tt);
            
            % Mostrar resultados
        disp('Parmetros:'); disp('---------------');
        fprintf(1,'Periodo = %g \nMesor = %g \nAmplitud = %g \nAcrofase = %g \np = %g\nR = %g\n',w,M,Amp,Acr,pVal,R);
    end
    
function rdbttnSin_Callback(hObject, eventdata, handles)
set (handles.txtFin,'Visible','Off');
set (handles.edtFin,'Visible','Off');
set (handles.txtMin,'Visible','Off');
set (handles.edtMin,'Visible','Off');
set (handles.txtIni,'String','Analizar con un nico periodo de # horas:');

function rdbttnMul_Callback(hObject, eventdata, handles)
set (handles.txtFin,'Visible','On');
set (handles.edtFin,'Visible','On');
set (handles.txtMin,'Visible','On');
set (handles.edtMin,'Visible','On');
set (handles.txtIni,'String','Analizar con un rango de periodos desde la hora:');

function edtMin_Callback(hObject, eventdata, handles)

function edtMin_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%------------------------- Cosinor --------------------------%

function coscos = cosniv (t,x,hri,hrf,cmin)
    %Algoritmo para establecer el anlisis de Cosinor
    k = 1;
    coscos = {};                   
    
    for i = hri : cmin/60 : hrf
        %[ Periodo  ,   Mesor   , Amplitud  , Acrofase  ,Valor de p ,% de ritmo]        
        [coscos{k,1},coscos{k,2},coscos{k,3},coscos{k,4},coscos{k,5},coscos{k,6}] = cper (t,x,(2*pi/i),0);
        k = k+1;
    end
    
    %Corregir las acrofases
    cosinor = cell2mat(coscos);
    acro = abs((rad2deg(cosinor(:,4))*6)/90);       
    cosinor (:,4) = acro;     
    
    array2table(cosinor, 'VariableNames', {'Periodo','Mesor','Amplitud','Acrofase','p','R'})

%Para obtener una matriz con todos los datos ordenados. Devuelve:
%[Periodo, Mesor, Amplitud, Acrofase, Valor de p]

%La funcin a continuacin fue adaptada de "Cosinor Analysis" por Casey Cox 
%(2008) en mathworks.com
function [w,M,Amp,phi,pVal,R] = cper (t,y,w,sm)
    alpha = 0.05;

    % Estimar parmetros
    n = length(t);

    % Obtener seno y coseno
    x = cos(w.*t);   z = sin(w.*t);

    % Hacer ecuaciones normales
    EN = [ n        sum(x)       sum(z)     sum(y);
           sum(x)   sum(x.^2)    sum(x.*z)    sum(x.*y);
           sum(z)   sum(x.*z)    sum(z.^2)    sum(z.*y);];

    RNE = rref(EN);
    M = RNE(1,4); beta = RNE(2,4); gamma = RNE(3,4);

    %Calcular amplitud y acrofase desde beta y gama
    Amp = sqrt(beta^2 + gamma^2);
    theta = atan(abs(gamma/beta));    % Acrofase

    %Calcular acrofase (phi) y la convierte de radianes a grados
    sb = sign(beta);
    sg = sign(gamma);
    if (sb == 1 || sb == 0) && sg == 1
        phi = -theta;
    elseif sb == -1 && (sg == 1 || sg == 0)
        phi = -pi + theta;
    elseif (sb == -1 || sb == 0) && sg == -1
        phi = -pi - theta;
    elseif sb == 1 && (sg == -1 || sg == 0)
        phi = -2*pi + theta;
    end

    %% II. Estadstica cosinor

    %Suma de cuadrados residuales (RSS)
    RSS = sum((y - (M + beta.*x + gamma.*z)).^2);
    
    %Suma de cuadrados totales (TSS)
    TSS = sum((y - mean(y)).^2);

    %Estimacin residual de la variacin
    sigma = sqrt(RSS/(n-3));

    %Parmetros para el intervalo de confianza del mesor
    X = 1/n * sum((x - mean(x)).^2);
    Z = 1/n * sum((z - mean(z)).^2);
    T = 1/n * sum((x - mean(x)).*(z - mean(z)));

    % Intervalo de confianza para el MESOR
    CI_M = tinv(1-alpha/2,n-3)*sigma*((((sum(x.^2))*(sum(z.^2)) - (sum(x.*z))^2)/(n^3*(X*Z - T^2)))^(1/2));

    %Estadstica Amplitud y Acrofase
    if sm == 1
        [CI_Amp_min, CI_Amp_max, CI_phi_min, CI_phi_max] = CIcalc(X,T,Z,beta,gamma,n,sigma,Amp,phi,alpha);
    end
    
    %Conversin de periodo a 24 horas
    w = 2*pi/w;
    
    %Obtener valor de p y porcentaje de ritmo R
    pVal = fpdf((n*(X*beta^2 + 2*T*beta*gamma + Z*gamma^2)/(2*sigma^2)),2,n-3);
       
    %R = 1 - (RSS/TSS);
    R = 100 * ((TSS-RSS)/TSS);


% --- Executes on slider movement.
function sldrIni_Callback(hObject, eventdata, handles)
    %Si se pasa el slider
    if (get(handles.sldrIni,'Value') > get(handles.sldrFin,'Value'))
        %Cambiar el valor del slider por el mnimo
        set(handles.sldrIni,'Value',get(handles.sldrIni,'Min'));       
    
        %Cambiar el edit box con el valor del slider
        set (handles.edtIniDes,'String',round((get(handles.sldrIni,'Value')/get(handles.sldrIni,'Max')*handles.axsDat.XLim(2))*100)/100);
        
        %Graficar lnea
        delete (handles.lini)
        x = [(get(handles.sldrIni,'Value')/get(handles.sldrIni,'Max'))*handles.axsDat.XLim(2) , (get(handles.sldrIni,'Value')/get(handles.sldrIni,'Max'))*handles.axsDat.XLim(2)];
        y = handles.axsDat.YLim;

        axes(handles.axsDat);
        handles.lini = plot(x,y,'r');
        guidata(hObject, handles);

        return;                
    end

    %Cambiar el edit box con el valor del slider
    set (handles.edtIniDes,'String',round((get(handles.sldrIni,'Value')/get(handles.sldrIni,'Max')*handles.axsDat.XLim(2))*100)/100);
    
    %Graficar
    delete (handles.lini)
    x = [(get(handles.sldrIni,'Value')/get(handles.sldrIni,'Max'))*handles.axsDat.XLim(2) , (get(handles.sldrIni,'Value')/get(handles.sldrIni,'Max'))*handles.axsDat.XLim(2)];
    y = handles.axsDat.YLim;

    axes(handles.axsDat);
    handles.lini = plot(x,y,'r');
    guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function sldrIni_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function sldrFin_Callback(hObject, eventdata, handles)
    %Si se pasa el slider
    if (get(handles.sldrFin,'Value') < get(handles.sldrIni,'Value'))
        %Cambiar el valor del slider al valor mximo
        set(handles.sldrFin,'Value',get(handles.sldrFin,'Max'));
                
        %Cambiar el edit box con el valor del slider
        set (handles.edtFinDes,'String',round(((get(handles.sldrFin,'Value')/get(handles.sldrFin,'Max'))*handles.axsDat.XLim(2))*100)/100)
        
        %Graficar
        delete(handles.linf)
        x = [(get(handles.sldrFin,'Value')/get(handles.sldrFin,'Max'))*handles.axsDat.XLim(2) , (get(handles.sldrFin,'Value')/get(handles.sldrFin,'Max'))*handles.axsDat.XLim(2)];
        y = handles.axsDat.YLim;

        axes(handles.axsDat);
        handles.linf = plot(x,y,'r');
        guidata(hObject, handles);

        return;
    end
    
    %Cambiar el edit box con el valor del slider
    set (handles.edtFinDes,'String',round(((get(handles.sldrFin,'Value')/get(handles.sldrFin,'Max'))*handles.axsDat.XLim(2))*100)/100)
    
    %Graficar
    delete (handles.linf)
    x = [(get(handles.sldrFin,'Value')/get(handles.sldrFin,'Max'))*handles.axsDat.XLim(2) , (get(handles.sldrFin,'Value')/get(handles.sldrFin,'Max'))*handles.axsDat.XLim(2)];
    y = handles.axsDat.YLim;

    axes(handles.axsDat);
    handles.linf = plot(x,y,'r');
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function sldrFin_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function edtFinDes_Callback(hObject, eventdata, handles)

    x = get(hObject,'String');
    
    if ((isstrprop(x,'digit') ~= 1) | ...
        (str2double(x) > handles.axsDat.XLim(2)) == 1) | ...
        (str2double(x) < get(handles.sldrIni,'Value')/get(handles.sldrIni,'Max')*handles.axsDat.XLim(2))                
            set (handles.edtFin,'String','');
            return;
    end
    x = str2double(x);    
    val = (x * get(handles.sldrIni,'Max'))/handles.axsDat.XLim(2);
    set (handles.sldrFin,'Value',val);
    
    %Graficar
    delete (handles.linf)
    x = [(get(handles.sldrFin,'Value')/get(handles.sldrFin,'Max'))*handles.axsDat.XLim(2) , (get(handles.sldrFin,'Value')/get(handles.sldrFin,'Max'))*handles.axsDat.XLim(2)];
    y = handles.axsDat.YLim;

    axes(handles.axsDat);
    handles.linf = plot(x,y,'r');
    guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function edtFinDes_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtIniDes_Callback(hObject, eventdata, handles)

    %Toma el valor, lo checa y cambia en la escala del Slider
    x = get(hObject,'String');
    
    if ((isstrprop(x,'digit') ~= 1) |  (str2double(x) <= 0) | ...
            (str2double(x) > handles.axsDat.XLim(2))==1) | ... 
            (str2double(x) > get(handles.sldrFin,'Value')/get(handles.sldrFin,'Max')*handles.axsDat.XLim(2))
                set (handles.edtIniDes,'String','');
                return;
    end
    x = str2double(x);    
    val = (x * get(handles.sldrIni,'Max'))/handles.axsDat.XLim(2);
    set (handles.sldrIni,'Value',val);
        
    %Graficar lnea
    delete (handles.lini)
    x = [(get(handles.sldrIni,'Value')/get(handles.sldrIni,'Max'))*handles.axsDat.XLim(2) , (get(handles.sldrIni,'Value')/get(handles.sldrIni,'Max'))*handles.axsDat.XLim(2)];
    y = handles.axsDat.YLim;

    axes(handles.axsDat);
    handles.lini = plot(x,y,'r');
    guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function edtIniDes_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function axsDat_CreateFcn(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function uibuttongroup1_CreateFcn(hObject, eventdata, handles)


% --- Executes when selected object is changed in uibuttongroup1.
function uibuttongroup1_SelectionChangedFcn(hObject, eventdata, handles)
