function varargout = guiOndeletas(varargin)

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @guiOndeletas_OpeningFcn, ...
                   'gui_OutputFcn',  @guiOndeletas_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT
end

% --- Executes just before guiOndeletas is made visible.
function guiOndeletas_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

    %Obtener datos y graficarlos
    valores = getappdata (BiCA,'valores');
    vectt = getappdata (BiCA,'vectt');
    nomb = getappdata (BiCA,'nomb');

    axes(handles.axsDat);
    cla;
    plot (vectt,valores);

    xlim ([vectt(1) vectt(end)]);
    hold on;

    xlabel('Tiempo');
    ylabel(nomb);

   %Sliders
    %Inicial
    set(handles.sldrIni,'Min',1);
    set(handles.sldrIni,'Max',length(vectt));
    set(handles.sldrIni,'Value',1);
    
    x = [1,1];
    y = handles.axsDat.YLim;
    axes(handles.axsDat);
    handles.lini = plot(x,y,'r');
    set(handles.lini,'Visible','off')    
    guidata(hObject, handles);
    
    %Final
    set(handles.sldrFin,'Min',1);
    set(handles.sldrFin,'Max',length(vectt));
    set(handles.sldrFin,'Value',length(vectt));
    
    x = [get(handles.sldrFin,'Max'),get(handles.sldrFin,'Max')];
    y = handles.axsDat.YLim;
    axes(handles.axsDat);    
    handles.linf = plot(x,y,'r');
    set(handles.linf,'Visible','off')
   
   %Edts   
    %Final
    set (handles.edtFin, 'String', floor(handles.axsDat.XLim(end)));
    
    guidata(hObject, handles);
% UIWAIT makes guiOndeletas wait for user response (see UIRESUME)
% uiwait(handles.figure1);
end

% --- Outputs from this function are returned to the command line.
function varargout = guiOndeletas_OutputFcn(hObject, eventdata, handles) 

varargout{1} = handles.output;
end

function edtDesc_Callback(hObject, eventdata, handles)

end

function edtDesc_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
end


function rdbttnCWT_Callback(hObject, eventdata, handles)
    set(handles.txtInfo,'Visible','Off');
    set(handles.edtDesc,'Visible','Off');

    set (handles.rdbttn1,'String','Morse');
    set (handles.rdbttn2,'String','Morlet');
    set (handles.rdbttn3,'Visible','on');
    set (handles.bttngrpFP,'Visible','on');
end

function rdbttnDWT_Callback(hObject, eventdata, handles)
    set(handles.txtInfo,'Visible','On');
    set(handles.edtDesc,'Visible','On');
    
    set (handles.rdbttn1,'String','Harr');
    set (handles.rdbttn2,'String','Daubechies 4');
    set (handles.rdbttn3,'Visible','off');
    set (handles.bttngrpFP,'Visible','off');
end

function pshbttnBandas_Callback(hObject, eventdata, handles)
    clear handles.wt
    clear handles.datos
    
    valores = getappdata (BiCA,'valores');
    handles.sel = get(get(handles.bttngrpFP,'SelectedObject'),'Tag');
    handles.datos = valores (floor(get(handles.sldrIni,'Value')):floor(get(handles.sldrFin,'Value')));
    handles.wt = get(get(handles.btngrpFamilia,'SelectedObject'),'Tag');
    
    setappdata (guiOndeletas,'wt',handles.wt);
    setappdata (guiOndeletas,'datos',handles.datos);
    setappdata (guiOndeletas,'sel',handles.sel);
    
    guidata(hObject,handles);
    
    bandas = guiBandas();
end

function pshbtnAceptar_Callback(hObject, eventdata, handles)

    valores = getappdata (BiCA,'valores');
    datos = valores (floor(get(handles.sldrIni,'Value')):floor(get(handles.sldrFin,'Value')));
    info = str2double (get(handles.edtDesc,'String'));        
    
    if isempty(info)
        msgbox('Recuadro vaco', 'Error','warn');
        return;
    end
    
    %Discrimina entre CWT y DWT
    if get(handles.rdbttnCWT,'Value') ~= 1              %DWT
        switch get(get(handles.btngrpFamilia,'SelectedObject'),'Tag')
            case 'rdbttn1' 
                harr(datos,info);
            case 'rdbttn2', an = 'd4';
                daub4(datos,info);
            case 'rdbttn3', an = 'mx';
        end
    else                                                %CWT
        sel = get(get(handles.bttngrpFP,'SelectedObject'),'Tag');
        %Discrimina entre anlisis por frecuenci y periodo 
        if strcmp('rdbttnFrec',sel)                     %Anlisis por frecuencia
            fm = getappdata (BiCA,'fm');
            if fm == 0
                msgbox('Frec. de muestreo no especificada en interfaz principal', 'Error','warn');
                return;
            end
            switch get(get(handles.btngrpFamilia,'SelectedObject'),'Tag')
                case 'rdbttn1' 
                    figure;
                    cwt(datos,'morse',fm,'NumOctaves',floor(log2(numel(datos)))-1,'VoicesPerOctave',48);
                case 'rdbttn2'
                    figure;
                    cwt(datos,'amor',fm,'NumOctaves',floor(log2(numel(datos)))-1,'VoicesPerOctave',48);
                case 'rdbttn3'
                    figure;
                    cwt(datos,'bump',fm,'NumOctaves',floor(log2(numel(datos)))-1,'VoicesPerOctave',48);
            end                           
            xlabel('Tiempo'); ylabel('Frecuencia');  title('Escalograma'); colorbar ('off');
            c = colorbar;   
            c.Label.String = 'Magnitud';
        else                                            %Anlisis por periodo                    
            dxd = getappdata (BiCA,'dxd');
            if dxd == 0
                msgbox('Datos por da no especificados en interfaz principal', 'Error','warn');
                return;
            end
            switch get(get(handles.btngrpFamilia,'SelectedObject'),'Tag')
                case 'rdbttn1' 
                    figure;
                    cwt(datos,'morse',days(1/dxd),'NumOctaves',floor(log2(numel(datos)))-1,'VoicesPerOctave',48);
                case 'rdbttn2'
                    figure;
                    cwt(datos,'amor',days(1/dxd),'NumOctaves',floor(log2(numel(datos)))-1,'VoicesPerOctave',48);
                case 'rdbttn3'
                    figure;
                    cwt(datos,'bump',days(1/dxd),'NumOctaves',floor(log2(numel(datos)))-1,'VoicesPerOctave',48);
            end
            ylabel('Periodo (das)');
        end
    %Formato de grfica                    
    xlabel('Tiempo'); ylabel('Periodo');                
    title('Escalograma');
    c = colorbar;
    c.Label.String = 'Magnitud';    
    end
end

function rdbttn1_Callback(hObject, eventdata, handles)
end
function rdbttn2_Callback(hObject, eventdata, handles)
end


% --- Executes on slider movement.
function sldrIni_Callback(hObject, eventdata, handles)

    %Si se pasa el slider
    if (get(handles.sldrIni,'Value') > get(handles.sldrFin,'Value'))
        %Cambiar el valor del slider por el mnimo
        set(handles.sldrIni,'Value',get(handles.sldrIni,'Min'));       
    
        %Cambiar el edit box con el valor del slider
        set (handles.edtIni,'String',round((get(handles.sldrIni,'Value')/get(handles.sldrIni,'Max')*handles.axsDat.XLim(2))*100)/100);
        
        %Graficar lnea
        delete (handles.lini)
        x = [(get(handles.sldrIni,'Value')/get(handles.sldrIni,'Max'))*handles.axsDat.XLim(2) , (get(handles.sldrIni,'Value')/get(handles.sldrIni,'Max'))*handles.axsDat.XLim(2)];
        y = handles.axsDat.YLim;

        axes(handles.axsDat);
        handles.lini = plot(x,y,'r');
        guidata(hObject, handles);

        return;                
    end

    %Cambiar el editbox con el valor del slider
    set (handles.edtIni,'String',round((get(handles.sldrIni,'Value')/get(handles.sldrIni,'Max')*handles.axsDat.XLim(2))*100)/100);
    
    %Graficar
    delete (handles.lini)
    x = [(get(handles.sldrIni,'Value')/get(handles.sldrIni,'Max'))*handles.axsDat.XLim(2) , (get(handles.sldrIni,'Value')/get(handles.sldrIni,'Max'))*handles.axsDat.XLim(2)];
    y = handles.axsDat.YLim;

    axes(handles.axsDat);
    handles.lini = plot(x,y,'r');
    guidata(hObject, handles);
end
% --- Executes during object creation, after setting all properties.
function sldrIni_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
end


% --- Executes on slider movement.
function sldrFin_Callback(hObject, eventdata, handles)

    %Si se pasa el slider
    if (get(handles.sldrFin,'Value') < get(handles.sldrIni,'Value'))
        %Cambiar el valor del slider al valor mximo
        set(handles.sldrFin,'Value',get(handles.sldrFin,'Max'));
                
        %Cambiar el edit box con el valor del slider
        set (handles.edtFin,'String',round(((get(handles.sldrFin,'Value')/get(handles.sldrFin,'Max'))*handles.axsDat.XLim(2))*100)/100)
        
        %Graficar
        delete(handles.linf)
        x = [(get(handles.sldrFin,'Value')/get(handles.sldrFin,'Max'))*handles.axsDat.XLim(2) , (get(handles.sldrFin,'Value')/get(handles.sldrFin,'Max'))*handles.axsDat.XLim(2)];
        y = handles.axsDat.YLim;

        axes(handles.axsDat);
        handles.linf = plot(x,y,'r');
        guidata(hObject, handles);

        return;
    end
    
    %Cambiar el edit box con el valor del slider
    set (handles.edtFin,'String',round(((get(handles.sldrFin,'Value')/get(handles.sldrFin,'Max'))*handles.axsDat.XLim(2))*100)/100)
    
    %Graficar
    delete (handles.linf)
    x = [(get(handles.sldrFin,'Value')/get(handles.sldrFin,'Max'))*handles.axsDat.XLim(2) , (get(handles.sldrFin,'Value')/get(handles.sldrFin,'Max'))*handles.axsDat.XLim(2)];
    y = handles.axsDat.YLim;

    axes(handles.axsDat);
    handles.linf = plot(x,y,'r');
    guidata(hObject, handles);

end
% --- Executes during object creation, after setting all properties.
function sldrFin_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
end


function edtFin_Callback(hObject, eventdata, handles)

    %Tomar el valor, checarlo y cambiarlo en la escala del Slider
    x = get(hObject,'String');
    
    if ((isstrprop(x,'digit') ~= 1) | ...
        (str2double(x) > handles.axsDat.XLim(2)) == 1) | ...
        (str2double(x) < get(handles.sldrIni,'Value')/get(handles.sldrIni,'Max')*handles.axsDat.XLim(2))                
            set (handles.edtFin,'String','');
            return;
    end
    x = str2double(x);    
    val = (x * get(handles.sldrIni,'Max'))/handles.axsDat.XLim(2);
    set (handles.sldrFin,'Value',val);
    
    %Graficar
    delete (handles.linf)
    x = [(get(handles.sldrFin,'Value')/get(handles.sldrFin,'Max'))*handles.axsDat.XLim(2) , (get(handles.sldrFin,'Value')/get(handles.sldrFin,'Max'))*handles.axsDat.XLim(2)];
    y = handles.axsDat.YLim;

    axes(handles.axsDat);
    handles.linf = plot(x,y,'r');
    guidata(hObject, handles);
end

% --- Executes during object creation, after setting all properties.
function edtFin_CreateFcn(hObject, eventdata, handles)

    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
end


function edtIni_Callback(hObject, eventdata, handles)

    %Toma el valor, lo checa y cambia en la escala del Slider
    x = get(hObject,'String');
    
    if ((isstrprop(x,'digit') ~= 1) | ...
            (str2double(x) > handles.axsDat.XLim(2))==1) | ...
            (str2double(x) > get(handles.sldrFin,'Value')/get(handles.sldrFin,'Max')*handles.axsDat.XLim(2))
                set (handles.edtIni,'String','');
                return;
    end
    x = str2double(x);    
    val = (x * get(handles.sldrIni,'Max'))/handles.axsDat.XLim(2);
    set (handles.sldrIni,'Value',val);
        
    %Graficar lnea
    delete (handles.lini)
    x = [(get(handles.sldrIni,'Value')/get(handles.sldrIni,'Max'))*handles.axsDat.XLim(2) , (get(handles.sldrIni,'Value')/get(handles.sldrIni,'Max'))*handles.axsDat.XLim(2)];
    y = handles.axsDat.YLim;

    axes(handles.axsDat);
    handles.lini = plot(x,y,'r');
    guidata(hObject, handles);
end

% --- Executes during object creation, after setting all properties.
function edtIni_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
end


% --- Executes on button press in rdbttnPer.
function rdbttnPer_Callback(hObject, eventdata, handles)
end

% --- Executes on button press in rdbttnFrec.
function rdbttnFrec_Callback(hObject, eventdata, handles)   
end


%----- Transformada Harr por mtodo de convolucin a distintos niveles ---
function trans = harr (v,niv)
    trans = {};
    [trans{1,1},trans{1,2},trans{1,3},trans{1,4}] = harrconv (v,1);
    
    %Aplica transformada Harr a partir de nivel 2 de descomposicin.
    if niv > 1
        for j = 2 : niv
            [trans{j,1},trans{j,2},trans{j,3},trans{j,4}] = harrconv (trans{j-1,1},j);                
        end
    end
        
    %Grafica los distintos niveles de descomposicin.    
    scrsz = get(groot,'ScreenSize');
    figure('Name','Transformada por ondeleta Harr','OuterPosition',[scrsz(3)/2 scrsz(1)*30 scrsz(3)/2 scrsz(4)/2]); 
    
    subplot(niv+1,2,1);
    plot(v,'r'), grid on, title('Coeficientes Aproximacin'), ylabel('Seal original');
    xlim([1,length(v)]);
    
    subplot(niv+1,2,2);
    plot(v,'r'),grid on, title('Coeficientes Detalles'), ylabel('Seal original');
    xlim([1,length(v)]);
    
    for i = 0 : niv                
        if i == niv
            break;
        end
        subplot(niv+1,2,(i+1)*2+1);
        plot (trans{(i+1),3}), ylabel(strcat('A',num2str((i+1)))), grid on;
        xlim([1,length(trans{i+1,3})]);
        
        subplot(niv+1,2,(i+1)*2+2);
        plot (trans{(i+1),4}), ylabel(strcat('D',num2str((i+1)))), grid on;
        xlim([1,length(trans{i+1,4})]);
    end        
end

%Algoritmo para hacer transformada Harr
function [CofA,CofD,A,D] = harrconv (v,niv)        
    if mod (length(v),2) ~= 0 
        v(end) = [];
    end
    
    PadreHarr = [0.5 0.5];
    MadreHarr = [-0.5 0.5];
    
    %Convolucin entre la seal y la funcin Padre y Madre
    CofA = conv (v,PadreHarr);
    CofA = downsample (CofA,2,1);
    
    CofD = conv (v,MadreHarr);
    CofD = downsample (CofD,2,1);
   
    %Obtener A
    A = reshape ((CofA(:)*(ones (1,2^niv)))',1,[]);
    
    %Obtener D
    Dp = CofD(:) * (ones (1,2^niv/2));
    Dn = CofD(:) * (-1 .* ones (1,2^niv/2));
    D = reshape ([Dp,Dn]',1,[]);
end

% ------------------ Daubechies ----------------------- 
function trans = daub4 (v,niv)
    trans = {};
    [trans{1,1},trans{1,2},trans{1,3},trans{1,4}] = daubconv (v,1);
    
    if niv > 1
        for j = 2 : niv
            [trans{j,1},trans{j,2},trans{j,3},trans{j,4}] = daubconv (trans{j-1,3},j);                
        end
    end  
    
    %Grafica los distintos niveles de descomposicin.    
    scrsz = get(groot,'ScreenSize');
    figure('Name','Transformada por ondeleta Daubechies 4','OuterPosition',[scrsz(3)/2 scrsz(1)*30 scrsz(3)/2 scrsz(4)/2]); 
    
    subplot(niv+1,2,1);
    plot(v,'r'), grid on, title('Coeficientes Aproximacin'), ylabel('Seal original');
    xlim ([0 length(v)]);
    subplot(niv+1,2,2);
    plot(v,'r'),grid on, title('Coeficientes Detalles'), ylabel('Seal original');
    xlim ([0 length(v)]);
    
    for i = 0 : niv                
        if i == niv
            break;
        end
        subplot(niv+1,2,(i+1)*2+1);
        plot (trans{(i+1),1}),grid on, ylabel(strcat('A',num2str((i+1))));
        xlim ([0 length(trans{(i+1),1})]);
        
        subplot(niv+1,2,(i+1)*2+2);
        plot (trans{(i+1),2}),grid on, ylabel(strcat('D',num2str((i+1))));
        xlim ([0 length(trans{(i+1),2})]);
    end    
end

function [ValA,ValD,CofA,CofD]= daubconv (v,niv)  
    %Slo acepta nmeros pares
    if mod (length(v),2) ~= 0             
        v (end) = [];
    end
    
    %Asignando scaling numbers para la tendencia
    sn1 = (1+sqrt(3))/(4*sqrt(2));
    sn2 = (3+sqrt(3))/(4*sqrt(2));
    sn3 = (3-sqrt(3))/(4*sqrt(2));
    sn4 = (1-sqrt(3))/(4*sqrt(2));      
    
    PadreDaub = [sn4,sn3,sn2,sn1];
    MadreDaub = [-sn1,sn2,-sn3,sn4];     

    % Convolucin y downsample   
    CofA = conv (v,PadreDaub);    
    CofA = downsample (CofA(4:end),2);
    
    CofD = conv (v,MadreDaub);
    CofD = downsample (CofD(4:end),2);
    
    % Wrap up  
    A = conv ([v(end-1),v(end),v(1),v(2)],PadreDaub);
    D = conv ([v(end-1),v(end),v(1),v(2)],MadreDaub);
    
    CofA(end) = A (4);   CofD(end) = D (4);
    
    %Obtener coeficientes
    for i = 0 : length(v)/2-1
        if (i == length (v)/2-1)            
            PadreMat = vP {1} (:,:);
            MadreMat = vM {1} (:,:);
            PadreMat (i+1,:) = [sn3,sn4,zeros(1,2*i-2),sn1,sn2];
            MadreMat (i+1,:) = [sn2,-sn1,zeros(1,2*i-2),sn4,-sn3];
            continue
        end
        
        vP {1}(i+1,:) = [zeros(1,2*i),sn1,sn2,sn3,sn4,zeros(1,length(v)-(2*(i+1)+2))];
        vM {1}(i+1,:) = [zeros(1,2*i),sn4,-sn3,sn2,-sn1,zeros(1,length(v)-(2*(i+1)+2))];
    end
    
    ValA = CofA'*PadreMat; 
    ValD = CofD'*MadreMat;
end
